-------------------------------------------
-- © 2020 Brad Dunbar, All rights reserved.
-------------------------------------------
--local mySlots = isServer( )


env.setErrorMessageBoxEnabled(false)
gTargets = {} -- TABLE FOR ALL THE TARGETS INFORMTION
gMissionsRunning = {} -- TO HOLD THE MISSIONS RUNNINGS
gHiddenTargets = {} --TARGETS THAT ARE STILL HIDDEN FROM GROUP REQUESTING THEM
gLocationTriggers = {} -- TARGETS THAT ARE HIDDEN AND SPAWNED WITH A FRIENDLY OR ENEMY BEING CLOSE

if gDev ~= nil then 
	Debugging = true
	DebugFilter = "EventHandler"
	gClearView = false
	env.setErrorMessageBoxEnabled(true)
end

function GetNewMission ()
	-- if Debugging == true then  printDebug ( "EventHandler" , "Get A New Mission" , 10 ) end
end

function doMenuItems (input)

	local myLanguage = gPlayerGroups[input.group].preferences.language

	if input.action == 'newtarget' then
		getNewTarget (input)
	end
	
	if input.action == 'difficulty' then
		setGroupDifficulty (input)
	end
	
	if input.action == 'targetrange' then
		setGroupTargetRange (input)
	end
	
	if input.action == 'detectrange' then
		setGroupDetectRange (input)
	end
	
	if input.action == 'setlanguage' then
		setLanguage (input)
	end
	
	if input.action == 'setmeasurements' then
		setMeasurements (input)
	end
	
	if input.action == "vectors" then
		doVectors (input)
	end
	
	if input.action == "tanker" then
		activateTanker (input)
	end
	
	if input.action == "historicalenemies" then
		historicalAccuracy (input)
	end
	
	if input.action == "jumpedpercent" then
		jumpPercent ( input )
	end
	
	if input.action == "WWIIasset" then
		setAssetPack ( input )
	end

	if input.action == 'destroy' then
		destroyUnitOne ( input )
	end
	
	if input.action == 'land' then
		local myTargetUnitName = Unit.getName ( Group.getByName(gTargets[input.group].groups[1].name):getUnit(1) )
		doUnitLandClosestAirfield ( {unit=myTargetUnitName , coalition=Unit.getCoalition(Unit.getByName(myTargetUnitName ))} )
	end

	if input.action == 'missions' then
		doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=gSayThis[myLanguage].gamepause })
		timer.scheduleFunction(missionSelector, input, timer.getTime()+ .5 )  
	end
	
	if input.action == 'end_mission' then
		end_mission_RTB ( input )
	end
	
	if input.action == 'parking' then
		fullUpParking ( input )
	end
	
	if input.action == 'findbeach' then
		findBeach ( input )
	end	
end

function setNewTargetMenu ( input )
	--- find all the target category that match player aircraft
	local myTargets = {}
	local myCategories ={ mission={category="blank", } , category = CombatCategory.ZRandom , enterservice=input.enterservice , accurate=input.accurate, retired=input.retired, country=input.country }
	myTargets = checkTargetTables (myCategories) -- GET ALL THE TARGETS THAT MATCH THIS AIRCRAFT TYPE
	local myCounts = {}
	for targetCountKey,targetCountValue in pairs(myTargets) do
		myCounts[targetCountValue.category] = true -- THERE IS A MATCHING TARGET TYPE FOR THIS AIRCRAFT
	end
	myCounts[MissionCombat.ZANYRANDOM.category] = true -- EVERYONE GETS A RANDOM CHOICE

	if gPlayerGroups[input.group].retired >= 1953 or gWWIIAssets == true then -- IN ORDER TO REACH THE FIRST BOMBER AND TANK WITHOUT wwii ASSET
		myCounts[MissionCombat.CONVOYARMORED.category] = true -- EVERY AIRCRAFT TYPE MATCHES CONVOY
		myCounts[MissionCombat.ESCORT.category] = true -- EVERY AIRCRAFT TYPE MATCHES ESCORT
		myCounts[MissionCombat.OUTPOST.category] = true -- EVERY AIRCRAFT TYPE MATCHES OUTPOST
	end
	

	
	-- local menuName = "New Target "
	-- local menu1 = missionCommands.addSubMenu(menuName, commandDB[menuName] )
	
	--for missionKey,missionValue in pairs(gMissionMenu) do 
	for missionKey,missionValue in pairs(gSayThis[gPlayerGroups[input.group].preferences.language].menu_mission) do 
		local subMenu = missionCommands.addSubMenuForGroup(input.groupID, missionValue,input.menu)
		

		local mySortedCTable= {}
		for n in pairs(CombatCategory) do table.insert(mySortedCTable, n) end
		table.sort(mySortedCTable)
		for combatTypeKey , combatTypeValue in ipairs(mySortedCTable) do 
		
			local myTranslate = gSayThis[gPlayerGroups[input.group].preferences.language].menu_category[CombatCategory[combatTypeValue]] 
			--local combatTypeMenu = missionCommands.addSubMenuForGroup(input.groupID,CombatCategory[combatTypeValue],subMenu)
			local combatTypeMenu = missionCommands.addSubMenuForGroup(input.groupID,myTranslate,subMenu)
			local mySortedTable= {}
			for n in pairs(MissionCombat) do table.insert(mySortedTable, n) end
			table.sort(mySortedTable)
			for typeKey,typeValue in ipairs(mySortedTable) do				
				--if MissionCombat[typeValue].combat == CombatCatagory[combatTypeValue] then 
				if MissionCombat[typeValue].combat == CombatCategory[combatTypeValue] and myCounts[MissionCombat[typeValue].category] == true then 
					local menuItem = missionCommands.addCommandForGroup(input.groupID, MissionCombat[typeValue].desc, combatTypeMenu , doMenuItems, {action = "newtarget" ,group=input.group, medium=MissionCombat[typeValue].combat, mission=MissionCombat[typeValue] , menu=missionValue , category=CombatCategory[combatTypeValue] })					
				end
			end
			
		end
	end
end 

function setGroupDifficulty ( input )
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myDiffictulyWas = gPlayerGroups[input.group].preferences.difficulty
	local mySetting = input.setting

	
	gPlayerGroups[input.group].preferences.difficulty = input.setting

	local myDifficultySettings = {[1]=gSayThis[myLanguage].menu_normal , [2]=gSayThis[myLanguage].menu_hard , [3]=gSayThis[myLanguage].menu_challenging , [4]=gSayThis[myLanguage].menu_random }

	local myText = gSayThis[myLanguage].menu_difficulty .. " " .. gSayThis[myLanguage].was .. " " .. myDifficultySettings[myDiffictulyWas] .. ". " .. gSayThis[myLanguage].menu_difficulty  .." " .. gSayThis[myLanguage].nowis .. " " .. 
	
	myDifficultySettings[gPlayerGroups[input.group].preferences.difficulty] .. " " .. gSayThis[myLanguage].sayfor .. " " .. gSayThis[myLanguage].group .. " " ..  input.group
	
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	
	if gSaveGroupDefaults == true then gDifficulty = gPlayerGroups[input.group].preferences.difficulty end 
		
end 

function setLanguage ( input )
	gPlayerGroups[input.group].preferences.language = input.setting
	local myText = gSayThis[input.setting].languagenow .. " " .. gSayThis[input.setting].sayfor .. " " .. gSayThis[input.setting].group .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	if gSaveGroupDefaults == true then gLanguage = gPlayerGroups[input.group].preferences.language end 
	
end 

function setGroupDetectRange ( input )

	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myWasSetting = gPlayerGroups[input.group].preferences.targetdetect
	
	gPlayerGroups[input.group].preferences.targetdetect = input.setting
	
	local myNowSetting = gPlayerGroups[input.group].preferences.targetdetect/1000
	local myMeasure = gPlayerGroups[input.group].preferences.measure
	local myUnitOfMeasure = gSayThis[myLanguage].kilometers
	local myWasSettingConverted = myWasSetting/1000
	
	if myMeasure == gSayThis[myLanguage].feet then 
		myWasSettingConverted = myWasSetting*MILES 
		myUnitOfMeasure = gSayThis[myLanguage].miles
		myNowSetting =   gPlayerGroups[input.group].preferences.targetdetect*MILES 
	end 

	local myText =  gSayThis[myLanguage].target .. " " .. gSayThis[myLanguage].menu_detectiondistance .. " " .. gSayThis[myLanguage].was .. " " .. string.format("%.1f" , myWasSettingConverted ) .. " " .. myUnitOfMeasure .. " " .. gSayThis[myLanguage].nowis  .. " " .. string.format("%.1f", myNowSetting) .. " " .. myUnitOfMeasure .." " .. gSayThis[myLanguage].sayfor .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })

	if gSaveGroupDefaults == true then gDetectRange = input.desc end 
	
end 

function setGroupTargetRange ( input )

	
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myWasSetting = gPlayerGroups[input.group].preferences.targetrange
	
	gPlayerGroups[input.group].preferences.targetrange = input.setting
	gPlayerGroups[input.group].preferences.flightlength =  input.desc
	
	local myNowSetting = gPlayerGroups[input.group].preferences.targetrange/1000
	local myMeasure = gPlayerGroups[input.group].preferences.measure
	local myUnitOfMeasure = gSayThis[myLanguage].kilometers
	local myWasSettingConverted = myWasSetting/1000
	
	if myMeasure == gSayThis[myLanguage].feet then 
		myWasSettingConverted = myWasSetting*MILES 
		myUnitOfMeasure = gSayThis[myLanguage].miles
		myNowSetting =   gPlayerGroups[input.group].preferences.targetrange*MILES 
	end 

	local myText =  gSayThis[myLanguage].flightto .. " " .. gSayThis[myLanguage].was .. " " .. string.format("%.1f" , myWasSettingConverted ) .. " " .. myUnitOfMeasure .. " " .. gSayThis[myLanguage].nowis  .. " " .. string.format("%.1f", myNowSetting) .. " " .. myUnitOfMeasure .." " .. gSayThis[myLanguage].sayfor .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
	
	if gSaveGroupDefaults == true then 
		gFlightRange = gPlayerGroups[input.group].preferences.flightlength 
	end 

end 

function setMeasurements ( input )
	gPlayerGroups[input.group].preferences.measure = input.setting
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myText = gSayThis[myLanguage].distancenowin .. " " .. gPlayerGroups[input.group].preferences.measure .. " " .. gSayThis[myLanguage].sayfor .. " " .. gSayThis[myLanguage].group .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	
	if gSaveGroupDefaults == true then gUnitsOfMeasure = gPlayerGroups[input.group].preferences.measure end
end

function historicalAccuracy ( input )
	gPlayerGroups[input.group].preferences.historicalaccurate = input.setting
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myText = gSayThis[myLanguage].historical_enemies .. " " .. gPlayerGroups[input.group].preferences.historicalaccurate .. " " .. gSayThis[myLanguage].sayfor .. " " .. gSayThis[myLanguage].group .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	
	if gSaveGroupDefaults == true then gHistoricalFoes = gPlayerGroups[input.group].preferences.historicalaccurate end 
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})	
end

function setAssetPack ( input )
 
	gPlayerGroups[input.group].preferences.assetpack = input.setting
		
	local myLanguage = gPlayerGroups[input.group].preferences.language
	
	local mySetting = gSayThis[myLanguage].menu_installed
	if input.setting == false then mySetting = gSayThis[myLanguage].menu_notinstalled end 
	
	local myText = gSayThis[myLanguage].menu_wwiiassetpack .. " "  .. gSayThis[myLanguage].sayfor .. " " .. gSayThis[myLanguage].group .. " " ..  input.group .. " " .. 
	gSayThis[myLanguage].nowis .. " " .. mySetting
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
		
	if gSaveGroupDefaults == true then gWWIIAssets = gPlayerGroups[input.group].preferences.assetpack end
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})

end

function jumpPercent ( input )
	gPlayerGroups[input.group].preferences.jumpedpercent = input.setting
	local myLanguage = gPlayerGroups[input.group].preferences.language
	local myText = gSayThis[myLanguage].jumped_percent .. " " .. gPlayerGroups[input.group].preferences.jumpedpercent .. " " .. gSayThis[myLanguage].sayfor .. " " .. gSayThis[myLanguage].group .. " " ..  input.group
	doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	gPlayerGroups[input.group].interdiction.count = 0
	gPlayerGroups[input.group].interdiction.percent = 0
	
	if gSaveGroupDefaults == true then gJumpedPercent = gPlayerGroups[input.group].preferences.jumpedpercent end 
		
end 

function putPlayerIntoSquad ( input )
	input.coalition = 2
	local myPlayersList = coalition.getPlayers(input.coalition)
	if myPlayersList ~= nil then
		for key,value in pairs(myPlayersList) do -- ITERATE THROUGH THE A2A TABLE
			if gSquad.leader == nil then 
				gSquad.leader = value
				gSquad.leadername = Unit.getName(gSquad.leader)			
			end
			local myUnitName = Unit.getName(value)
			if gSquad.members[myUnitName] == nil then 
				gSquad.members[myUnitName] = value 
				gSquad.joinorder[#gSquad.joinorder+1] = myUnitName
			end 
		end
	end
end 

function removePlayerFromSquad ( input )
	input.coalition = 2
	if input.unit == Unit.getName(gSquad.leader)  then
		table.remove(gSquad.joinorder, 1)
	end 
	table.remove(gSquad.members, input.unit)
end

function eventLoop ()
		if (math.fmod (timer.getTime(), 60 )  < 1 ) then

			doInstructPlayers (  )

		end
		if (math.fmod (timer.getTime(), 10 )  < 1 ) then
			cleanOrphaned ()
		end
		if (math.fmod (timer.getTime(), 55 )  < 1 ) then
			doCalculateJumpPercent (  ) -- SEE IF ANY GROUPS NEED TO BE INTREDICTED
		end	
		if (math.fmod (timer.getTime(), 5 )  < 1 ) then
			-- checkGroups (  ) 
			hiddenTargets ()
						-- for group_name ,group_value in pairs(gHiddenTargets) do
				-- -- if Debugging == true then printDebug ("EventHandler" , "Groups active: " .. group_name , 10 ) end 
				
				-- if gPlayerGroups[group_name] ~= nil then 
					-- local myAllUnitsAirborne = true
					
					-- -- -- ARE WE REQUIRED VIA PREFERENCES TO HAVE ALL GROUP MEMBERS AIRBORNE
					-- if gGroupMustBeAirborne == true then
						-- for unit_name ,unit_value in pairs(gPlayerGroups[group_name].units) do
							-- if Unit.inAir(Unit.getByName(unit_value.name)) == false then
								-- --if Debugging == true then printDebug ("EventHandler" , "Unit On the ground " .. unit_value.name  , 10 ) end 
								-- myAllUnitsAirborne = false							
							-- end 
						-- end 
					-- end 
					-- -- IS ANY MEMBER OF THE GROUP CLOSE ENOUGH
					-- for unit_name ,unit_value in pairs(gPlayerGroups[group_name].units) do 
						-- myDistance = getDistanceBetweenUnitAndPoint( unit_value.name, gTargets[group_name].startpoint )
						-- --if Debugging == true then printDebug ("EventHandler" , "Check unmask " ..  myDistance .. " " .. gPlayerGroups[group_name].preferences.targetdetect  , 10 ) end 
						-- -- if myDistance < gPlayerGroups[group_name].preferences.targetdetect then
						-- if myDistance < gPlayerGroups[group_name].preferences.targetdetect and myAllUnitsAirborne == true then
							-- --if Debugging == true then printDebug ("EventHandler" , "Player: " .. unit_value.name .. " of group: ".. group_name .. " near: " .. group_value.target, 10 ) end 
							-- for target_name ,target_value in pairs( group_value.groups) do 
								
							-- --	if target_value.friendlytrigger == nil then
									-- trigger.action.activateGroup(Group.getByName(target_value.name ))
									-- gVisibleTargets[target_value.name] = gTargets[group_name]
							-- --	end

							-- end 
							-- gTargets[group_name].activated = true
							-- gHiddenTargets[group_name] = nil 

							-- --gTargets[group_name].phrasecount = gTargets[group_name].phrasecount + 1
							-- doInstructPlayers ( {group=group_name} )
						-- end 
					-- end
				-- end
			-- end
			
			-- for group_name ,group_value in pairs(gLocationTriggers) do
				-- if gTargets[group_name].activated == true then
					-- -- myDistance = getDistanceBetweenUnitAndPoint( unit_value.name, gTargets[group_name].startpoint )
					-- doLocationTrigger ({group=group_name , value=group_value})
				-- end 
			-- end 
		end
		
		if (math.fmod (timer.getTime(), 30 )  < 1 ) then
			for group ,value in pairs(gMissionsRunning) do
				if value.groups ~= nil then 
					local units_alive = false
					for enemygroup ,enemyvalue in pairs(value.groups) do
						-- for unit_index, unit_data in pairs(Group.getByName(enemyvalue.name):getUnits()) do
							-- if Unit.isExist(unit_data) == true then units_alive = true end 
						-- end
						if ( Group.getByName(enemyvalue.name) ~= nil and enemyvalue.killregenerates == nil ) or ( Group.getByName(enemyvalue.name) ~= nil and #value.groups==1) then
							units_alive = true 
						end

					end 
					if units_alive == false and value.endtrigger == nil  then 
						-- if Debugging == true then printDebug ("EventHandler" , "All Targets Destroyed" , 10 ) end 
						missionsAllTargetsDestroyed ( value )
						-- gMissionsRunning[group].endtrigger=true
					end 
				end
			end
		end
end

function doInstructPlayers ( input )
	local myTargets = {}
	local myLoopTimes = 1 
	local myInformAll = false 
	if input ~= nil then -- this message sent to specific group
		if gTargets[input.group] ~= nil then 
			myTargets[input.group] = gTargets[input.group]
			if input.instruct ~= nil then -- the word all in the instruct tells everyone
				myLoopTimes = #gPlayerGroups[input.group].units 
				myInformAll = true -- don't keep telling them
			end
		end
	else --gTargets~= nil then
	
		for group ,value in pairs(gTargets) do
			myTargets[group] = value 
		end 
		
	end 

	for group ,value in pairs(myTargets) do

		local myBuiltText = ""
		
		local myTargetUnitName = ""
		local myDistance = 0
		local myBearing = 0
		 
		local myTargetCounts = ""
		local myTargetType = myTargets[value.name].typename
		if gPlayerGroups[value.name] ~= nil and value.messages ~= nil then -- MAKE SURE PLAYER GROUPS ARE NOT ALL DEAD OR IN A LIMBO STATE
			if gPlayerGroups[value.name].preferences.difficulty > 1 then 
				myTargetCounts = "(" .. gPlayerGroups[value.name].preferences.difficulty .. ")" 
				myTargetType = " " .. myTargetType .."'s" 
			end 
			
			-- local myPhrase = value.message[value.phrasecount]
			
			
			
			local myLanguage = gPlayerGroups[value.name].preferences.language
			-- local myPhrase = gSayThis[myLanguage].clearedtofire 
			-- local myTextFlyHeading = gSayThis[myLanguage].flyheading
			local myForTargetType = gSayThis[myLanguage].fortargettype
			-- local myOnTargetType = gSayThis[myLanguage].ontargettype
			if value.missiontype ~= nil then -- IS THIS A MISSION GETS DIFFERENT WORDS THAN SINGLE TARGET
				myForTargetType = gSayThis[myLanguage].formissiontype 
			end
			if value.returntoairbase ~= nil then -- IS THIS A MISSION GETS DIFFERENT WORDS THAN SINGLE TARGET
				myForTargetType = gSayThis[myLanguage].rtb
			end
			
			
			--myTargetUnitName = Unit.getName ( Group.getByName(myTargets[value.name].groups[1].name ):getUnit(1) )
			--if Debugging == true then printDebug ("EventHandler" , "Say phrase " .. value.phrasecount , 10 ) end	
			for i=1,myLoopTimes do
				local myText = ""
				local myBearing =""
				local myDistance = ""
				local myTargetUnitName = ""
				local myBearingTo = ""
				local myBearingFrom = ""
				local myBearingDistance = ""
				
				--myText = value.message[value.phrasecount] .. " " .. myTargetType .. " " .. gSayThis[myLanguage].bearing  .. ": " .. myBearing 
				
				if value.activated==false then -- TARGET ISN'T UNMASKED YET SO GET DISTANCE TO UNMASK POINT INSTEAD
					myTargetUnitName = Unit.getName ( Group.getByName(value.triggers[value.phrasecount].atgroup):getUnit(1) )
					myDistance = string.format("%d", getDistanceBetweenUnitAndPoint( gPlayerGroups[value.name].units[i].name, myTargets[value.name].startpoint ))
					myBearing =  string.format("%03d", getBearingToPoint(gPlayerGroups[value.name].units[i].name, myTargets[value.name].startpoint))					
					myText = gSayThis[myLanguage][value.messages[value.phrasecount]]  .. ": " .. myBearing  .. " " .. myForTargetType .. ": " .. myTargetCounts  .. myTargetType
				elseif value.triggers[value.phrasecount].directto ~= nil then -- WE DIRECT TO SPECIFIC TARGET
					-- WHO IS STILL ALIVE
					local myDirectoDead = true 
					for alive_key , alive_value in pairs(value.triggers[value.phrasecount].directto) do
						if Group.getByName(alive_value.name) ~= nil then 
							myTargetUnitName = Unit.getName ( Group.getByName(alive_value.name):getUnit(1) )
							myDirectoDead = false
						end 
					end
					if myDirectoDead == true then -- 	every group we wanted to direct to is dead
						myTargetUnitName = Unit.getName ( Group.getByName(gTargets[value.name].groups[1].name):getUnit(1) )
					end 
					-- myTargetUnitName = Unit.getName ( Group.getByName(value.triggers[value.phrasecount].directto):getUnit(1) )
					myBearingFrom = gPlayerGroups[value.name].units[i].name
					myBearing =  string.format("%03d", getBearingToUnit(myBearingFrom, myTargetUnitName))
					myDistance = string.format("%d", getDistanceBetweenUnits( myBearingFrom , myTargetUnitName  ))
					local myBearingToUnitType = Unit.getTypeName(Unit.getByName(myTargetUnitName) )		
					if Targets[string.upper(myBearingToUnitType:gsub('[%p%c%s]', '') )].typename ~= nil then myBearingToUnitType = Targets[string.upper(myBearingToUnitType:gsub('[%p%c%s]', '') )].typename end				
					myText = gSayThis[myLanguage][value.messages[value.phrasecount]]  .. ": " .. myBearingToUnitType .. " " .. gSayThis[myLanguage].bearing  .. ": " .. myBearing 	 
				else -- 	EVERYTHING ELSE
					if value.triggers[value.phrasecount].atgroup ~= nil and #value.triggers[value.phrasecount].atgroup > 0 then --ITS A GROUP
						
						--if Debugging == true then printDebug ("EventHandler" , "Targets " ..  Group.getName(Group.getByName(value.triggers[value.phrasecount].atgroup)) , 10 ) end 

						-- only target left is not the one originally directed to
						if ( Group.getByName(value.triggers[value.phrasecount].atgroup):getUnit(1) ) == nil then
							for visible_group , visible_value in pairs(value.groups) do
								if gVisibleTargets[visible_value.name] ~= nil then 
									myTargetUnitName = Unit.getName ( Group.getByName(visible_value.name):getUnit(1) )
									myBearingFrom = gPlayerGroups[value.name].units[i].name
								end
							end	
						else
							myTargetUnitName = Unit.getName ( Group.getByName(value.triggers[value.phrasecount].atgroup):getUnit(1) )
							myBearingFrom = Unit.getName ( Group.getByName(value.triggers[value.phrasecount].groups[1].name):getUnit(1) )
						end
						local myFromUnitName = Unit.getName ( Group.getByName(value.triggers[value.phrasecount].groups[1].name):getUnit(1) )
						local myTargetUnitType = Unit.getTypeName(Unit.getByName(myTargetUnitName) )
						local myBearingToUnitType = Unit.getTypeName(Unit.getByName(myTargetUnitName) )
						
						if Targets[string.upper(myBearingToUnitType:gsub('[%p%c%s]', '') )] ~= nil then -- SOME DCS OBJECTS NOT IN THE MISSION TARGET TABLE
							if Targets[string.upper(myBearingToUnitType:gsub('[%p%c%s]', '') )].typename ~= nil then myBearingToUnitType = Targets[string.upper(myBearingToUnitType:gsub('[%p%c%s]', '') )].typename end	
						end
						myBearing =  string.format("%03d", getBearingToUnit(myBearingFrom, myTargetUnitName))
						myDistance = string.format("%d", getDistanceBetweenUnits( myBearingFrom , myTargetUnitName  ))
						myText = gSayThis[myLanguage][value.messages[value.phrasecount]]  .. ": " .. myBearingToUnitType .. " " .. gSayThis[myLanguage].bearing  .. ": " .. myBearing 	 
					elseif value.triggers[value.phrasecount].atpoint ~= nil then -- ITS A POINT
						myDistance = string.format("%d", getDistanceBetweenUnitAndPoint( gPlayerGroups[value.name].units[i].name , value.triggers[value.phrasecount].atpoint  ))
						myBearing =  string.format("%03d", getBearingToPoint(gPlayerGroups[value.name].units[i].name , value.triggers[value.phrasecount].atpoint))
						myText =  gSayThis[myLanguage][value.messages[value.phrasecount]]  .. ": " .. myBearing  .. " " .. myForTargetType .. ": " .. myTargetCounts  .. myTargetType
					end
					--myText =  myPhrase  .. " " .. myOnTargetType ..": " .. myTargetType .. " " .. gSayThis[myLanguage].bearing  .. ": " .. myBearing 
				end
				
				if myInformAll == true then -- EVERYONE GETS THEIR INDIVIDUAL DIRECTION
					myText = Unit.getPlayerName(Unit.getByName(gPlayerGroups[value.name].units[i].name)) .. " - " .. myText
				end 
				
				
				if Targets[myTargets[value.name].key].medium == "Airborne" then 
					local myAlt = getMSLmeters(myTargetUnitName)
					local myAltType =  gSayThis[myLanguage].at .. " " .. math.floor((myAlt*FEET)/500+ 1 * 0.5) * 500 .. " " ..  gSayThis[myLanguage].feet
					if AircraftType[gPlayerGroups[value.name].key].altimeter == "meters" then myAltType = gSayThis[myLanguage].at .. " " .. math.floor((myAlt)/100+ 1 * 0.5) * 100 .. " " ..  gSayThis[myLanguage].meters end 
					myText = myText .. " " .. myAltType .. " " .. gSayThis[myLanguage].msl
				end
					
				local myConvertedDistance = string.format("%.1f" , myDistance/1000) .. " " .. gSayThis[myLanguage].kilometers
				if gPlayerGroups[value.name].preferences.measure == "feet" then myConvertedDistance = string.format("%.1f" , myDistance*MILES) .. " " .. gSayThis[myLanguage].miles end
				myText = myText .. " " .. gSayThis[myLanguage].distance .. ": " .. myConvertedDistance
			
				myBuiltText = myBuiltText .. myText
				if myLoopTimes > 1 and i < myLoopTimes  then myBuiltText = myBuiltText .. "\n" end 
			end 

			doPrintThis ({clearview = gClearView  , group=value.name, duration= 30 , text=myBuiltText })
	
		end 
		
	end

end

function hiddenTargets ( )
	for group_name ,group_value in pairs(gHiddenTargets) do
		--if Debugging == true then printDebug ("EventHandler" , "Groups active: " .. group_name , 10 ) end 
		local myCloseEnough = false
		if gPlayerGroups[group_name] ~= nil and gTargets[group_name] ~= nil then 
			local myAllUnitsAirborne = true
			local i = gTargets[group_name].phrasecount
			local myDetectDistance = gPlayerGroups[group_name].preferences.targetdetect
			if group_value.triggers[i].endmission ~= nil then myDetectDistance = 3000 end --IF ITS THE END MISSION OR TARGET UNMASK ACTION IS 3K
			
			-- -- ARE WE REQUIRED VIA PREFERENCES TO HAVE ALL GROUP MEMBERS AIRBORNE
			if gGroupMustBeAirborne == true then
				for unit_name ,unit_value in pairs(gPlayerGroups[group_name].units) do
					if Unit.inAir(Unit.getByName(unit_value.name)) == false then
						myAllUnitsAirborne = false							
					end 
				end 
			end 
			-- IS ANY MEMBER OF THE GROUP CLOSE ENOUGH
			for allgroups_id ,allgroups_value in pairs(group_value.triggers[i].groups) do 
			-- for unit_name ,unit_value in pairs(gPlayerGroups[group_name].units) do 
				if Group.getByName(allgroups_value.name) ~= nil then -- group is alive
					for unit_name ,unit_value in pairs(Group.getByName(allgroups_value.name):getUnits()) do 
						local myWhat = ""
						local myWhere = ""
						local myDistance = 0

						if group_value.triggers[i].atgroup ~= nil then
							local myUnit = Group.getByName(group_value.triggers[i].atgroup):getUnit(1)
							-- if Debugging == true then printDebug ("EventHandler" , "Unit " .. Unit.getName(myUnit) , 10 ) end
							myDistance = getDistanceBetweenUnits( Unit.getName(unit_value), Unit.getName(myUnit)  )
						end
						
						if group_value.triggers[i].atpoint ~= nil then
							myDistance = getDistanceBetweenUnitAndPoint( Unit.getName(unit_value), group_value.triggers[i].atpoint )

						end		
						if myDistance < myDetectDistance and myAllUnitsAirborne == true then
							myCloseEnough = true
						end
					end 
				end
			end
			
			if myCloseEnough == true then
				--if Debugging == true then printDebug ("EventHandler" , "Close Enough" , 10 ) end 
				-- ACTIVATE THE GROUP
				for target_name ,target_value in pairs( group_value.groups[i]) do
					local myActivate = true
					if group_value.triggers[i].stayhidden ~= nil then myActivate = false end -- WE DON'T WANT THE TRIGGER POINT TO DISPLAY HIDDEN GROUP YET/AT ALL
					
					if target_value.killregenerates ~= nil then myActivate = false end 
					
					if myActivate == true then
						trigger.action.activateGroup(Group.getByName(target_value.name ))
						gVisibleTargets[target_value.name] = gTargets[group_name]
					end 
					-- if Debugging == true then printDebug ("EventHandler" , target_value.name, 10 ) end 
				end
				-- DO ANY EFFECTS
				if group_value.triggers[i].effects ~= nil then
				--	if Debugging == true then printDebug ("EventHandler" , "An Effect" , 10 ) end 
					if group_value.triggers[i].effects.smoke ~= nil then
						local myLand = group_value.triggers[i].effects.smoke.position
						myLand.y = land.getHeight{x = myLand .x, y = myLand .z}                           
						trigger.action.smoke(myLand , group_value.triggers[i].effects.smoke.color )   
					--	if Debugging == true then printDebug ("EventHandler" , "Smoke" , 10 ) end 
					end 
				
				end
				gTargets[group_name].activated = true
				gTargets[group_name].phrasecount = gTargets[group_name].phrasecount + 1

				if group_value.triggers[i].endmission ~= nil then
					local myText = gTargets[group_name].messages[gTargets[group_name].phrasecount]
					--doPrintThis ({clearview = gClearView  , group=group_name, duration= 30 , text=myText })
					end_mission_RTB ( {group=group_name , unit=Unit.getName ( Group.getByName(group_name):getUnit(1) )})

				else
					doInstructPlayers ( {group=group_name} )
					if gTargets[group_name].phrasecount > #group_value.groups then
						gHiddenTargets[group_name] = nil 
					end 
				end
				

			end 
		end
	end
end	

function removeTargetFromMission (input)
	
	for target_name ,target_value in pairs( input.groups ) do 

		local myGroup = Group.getByName( target_value.name )
		-- ANY MEMBERS OF THE GROUP A PLAYER SINCE IT CAN BE SCHEDULED
		local myAnyMembersPlayers = false
		if Group.getByName( target_value.name ) ~= nil then 
			for unit_key ,unit_value in pairs(Group.getUnits(myGroup)) do
				if gPlayers[Unit.getName(unit_value)] ~= nil then 
					myAnyMembersPlayers = true
				end 
			end
		end
		if myAnyMembersPlayers == false and Group.getByName( target_value.name ) ~= nil then
			if target_value.destroy ~= nil then 
				local myUnits = Group.getUnits(Group.getByName(target_value.name))
				for key , value in pairs(myUnits) do
					local myName = Unit.getName(value)
					
					if Unit.inAir(value) then 
						destroyUnit ( {unit=myName , power=30} )
					end 
					
					Unit.destroy( value ) 
					--if Debugging == true then printDebug ("EventHandler" , "Unit " .. myName.. " has been destroyed" , 10 ) end
				end 

			else
				Group.destroy( myGroup )
				--if Debugging == true then printDebug ("EventHandler" , "Group " .. target_value.name .. " has been destroyed" , 10 ) end
			end 
		end	
		if gVisibleTargets[target_value.name] ~= nil then gVisibleTargets[target_value.name] = nil end 
	end 
	
	if input.friendlygroups ~= nil then 
		for target_name ,target_value in pairs( input.friendlygroups) do 
			local myGroup = Group.getByName( target_value.name )
			if Group.getByName( target_value.name ) ~= nil then Group.destroy( myGroup ) end
			if gVisibleTargets[target_value.name] ~= nil then gVisibleTargets[target_value.name] = nil end 
		end

	end
	
	-- if gIntradiction[input.group] ~= nil then
		-- Group.destroy( Group.getByName( gIntradiction[input.group].group) )
		-- gIntradiction[input.group] = nil
	-- end
	

end

function cleanOrphaned ( )
	for targets_key , value in pairs(gTargets) do
		if value.orphaned ~= nil then 
			if (timer.getTime() - value.orphaned ) >= gOrphanedTime then 
				-- if Debugging == true then printDebug ("EventHandler" , "orphaned " .. value.orphaned .. " " .. timer.getTime() - value.orphaned  , 2 ) end 
				if gMissionsRunning[targets_key] ~= nil then 	
					removeActiveMissions ( {group=targets_key , } )
				else
					timer.scheduleFunction(removeTargetFromMission, {groups=gTargets[targets_key].groups, friendlygroups=gTargets[targets_key].friendlygroups , group=targets_key} , timer.getTime()+ (gTargetDestroyDelay*60) )
				end
				gTargets[targets_key] = nil
				gHiddenTargets[targets_key] = nil	
				gLocationTriggers[targets_key] = nil
			end 
		end 
	end
end 

function end_mission_RTB ( input )
	--gTargets[input.group] = { name=input.group, typename=myAirport.name, groups={ [1]={name=myAirport.name}}, rtb=true, startpoint=myAirport.point , activated=false,  key=string.upper(Targets.OUTPOST.type:gsub('[%p%c%s]', '') ), }
	--removeTargetFromMission( {groups=gTargets[input.group].groups, friendlygroups=gTargets[input.group].friendlygroups , group=input.group} )
	-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called  From End Mission/RTB " .. input.group , 10 ) end
	
	-- timer.scheduleFunction(removeTargetFromMission, {groups=gTargets[input.group].groups, friendlygroups=gTargets[input.group].friendlygroups , group=input.group} , timer.getTime()+ (gTargetDestroyDelay*60) )
	
	-- gTargets[input.group] = nil 
	-- gHiddenTargets[input.group] = nil
	-- gLocationTriggers[input.group] = nil

	removeActiveMissions ( {group=input.group , } )
	doRadioCommand (input)
	input.setting = gSayThis["English"].menu_vectors_items[3] -- WE WANT TO GIVE THE RTB HEADING
	doVectors (input)
end

function insertPlayerIntoMission ( input )
	local myUnitName = input.unit
	local myUnit = Unit.getByName( input.unit )
	local myGroupName = Group.getName(Unit.getGroup(myUnit))
	input.group = myGroupName
	local myKey = string.upper(Unit.getTypeName(myUnit):gsub('[%p%c%s]', '') )
	gPlayers[input.unit] = { unit = input.unit ,
							group = myGroupName , 
							country = AircraftType[myKey].country , 
							historicalcountry = AircraftType[myKey].country ,
							type=Unit.getTypeName(myUnit) ,
							key=myKey,
							enterservice = AircraftType[myKey].enterservice , 
							retired = AircraftType[myKey].retired,   }
	
	--if Debugging == true then printDebug ("EventHandler" , input.unit .. " in " ..myGroupName .. " flying " .. gPlayers[input.unit].type  .. " service life " .. gPlayers[input.unit].enterservice .. " - " .. gPlayers[input.unit].retired , 10 ) end 
	
	if gPlayerGroups[myGroupName] == nil then
		local myInterdiction = { probability=math.random (5,10) , rate=5, count=0 , percent=0 }
		gPlayerGroups[myGroupName] = { units={} , group = myGroupName ,
			preferences={ difficulty=gDifficultySettings[gDifficulty] , targetrange=gTargetRange[gFlightRange] , targetdetect=gTargetDetectRange[gDetectRange], 
							language=gLanguage , measure=gUnitsOfMeasure, flightlength=gFlightRange , historicalaccurate=gHistoricalFoes , jumpedpercent= gJumpedPercent , assetpack=gWWIIAssets}, 
			enterservice = gPlayers[input.unit].enterservice , 
			retired = gPlayers[input.unit].retired ,
			country = gPlayers[input.unit].country ,
			key = myKey ,
			historicalcountry = AircraftType[myKey].country ,
			type = AircraftType[myKey].type,
			interdiction  = myInterdiction  ,
			} 
		-- if gGroupPreferences[myGroupName] == nil then
			-- gGroupPreferences[myGroupName] = { unit=input.unit , preferences=gPlayerGroups[myGroupName].preferences }
			-- if Debugging == true then printDebug ("EventHandler" , "New Preferences Set" , 10 ) end
		-- elseif gGroupPreferences[myGroupName].unit == input.unit then
			-- gPlayerGroups[myGroupName].preferences = gGroupPreferences[myGroupName].preferences
			-- if Debugging == true then printDebug ("EventHandler" , "Preferences reset by player" , 10 ) end
		-- else
			-- if Debugging == true then printDebug ("EventHandler" , "Preferences Default" , 10 ) end
		-- end 
	end
	--gPlayerGroups[myGroupName][#gPlayerGroups[myGroupName]+1] = { name=input.unit  }
	
	local myUnitCount = #gPlayerGroups[myGroupName].units+1
	gPlayerGroups[myGroupName].units[myUnitCount] = { name=input.unit  }

	doRadioCommand ({unit=input.unit})

	if gTargetsExpire == false and gTargets[myGroupName] ~= nil then
		if gTargets[myGroupName].orphaned ~= nil then 
			-- if Debugging == true then printDebug ("EventHandler" , "Mission or target is no longer orphaned" , 10 ) end
			gTargets[myGroupName].orphaned = nil 
		end 
	end 
	
	
end

function removePlayerFromMission ( input )
	gPlayers[input.unit] = nil 
	-- if Debugging == true then printDebug ("EventHandler" , "Removing Player" .. Unit.getPlayerName(Unit.getByName(input.unit))  .. " from the mission"  , 30 ) end 
	local myGroup = Unit.getGroup(Unit.getByName(input.unit))
	
	local myUnits = Group.getUnits(myGroup)
	local myGroupName = Group.getName(myGroup)
	input.group = myGroupName
	--if Debugging == true then printDebug ("EventHandler" , "Units in " .. myGroupName .. " " .. #myUnits , 30 ) end 
	
	if #gPlayerGroups[myGroupName].units == 1 and gTargets[myGroupName] ~= nil and gTargetsExpire == true then
		-- if Debugging == true then printDebug ("EventHandler" , "Cleaning up target " .. myGroupName  , 30 ) end 		
		-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called  From remove player from mission" , 10 ) end
		if gMissionsRunning[input.group] ~= nil then 	
			removeActiveMissions ( {group=myGroupName , } )
		else
			timer.scheduleFunction(removeTargetFromMission, {groups=gTargets[myGroupName].groups, friendlygroups=gTargets[myGroupName].friendlygroups , group=myGroupName} , timer.getTime()+ (gTargetDestroyDelay*60) )
		end
		-- gTargets[myGroupName] = nil 
		-- gHiddenTargets[myGroupName] = nil 
		gTargets[myGroupName] = nil 
		gHiddenTargets[myGroupName] = nil	
		gLocationTriggers[myGroupName] = nil

	end 
	

	if #gPlayerGroups[myGroupName].units == 1 then 
		
		gPlayerGroups[myGroupName] =  nil 
		
		local myDoRemoveTargets = false
		local myRemainingGroups = {}
		if gTankers[myGroupName] ~= nil then
			--if Debugging == true then printDebug ("EventHandler" , "Need to remove tanker from mission"  , 5 ) end 
			-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called  From Remove tanker" , 10 ) end
			myRemainingGroups[#myRemainingGroups+1] = {name=gTankers[myGroupName].name}
			myDoRemoveTargets = true
			--timer.scheduleFunction(removeTargetFromMission, {groups={[1]=gTankers[myGroupName]}, group=myGroupName} , timer.getTime()+ (gTargetDestroyDelay*60) )
			gTankers[myGroupName] = nil
		end 

		-- THERE ARE FLIGHT AI REMAINING
		local myUnits = returnAllUnitsOfGroup ( input ) 
		-- for unit_name ,unit_value in pairs(myUnits.ai) do
		if myUnits.ai ~= nil then
			--if Debugging == true then printDebug ("EventHandler" , "Need to remove AI from mission for group " .. myGroupName  , 5 ) end 	--timer.scheduleFunction(removeTargetFromMission, {groups={[1]=input.group},} , timer.getTime()+ (gTargetDestroyDelay*60) )
			-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called from remove AI wingman" , 10 ) end
		--	local myRemainingGroups = {[1] = {name=myGroupName} }
			myRemainingGroups[#myRemainingGroups+1] = {name=myGroupName , destroy=true}
			myDoRemoveTargets = true
			--timer.scheduleFunction(removeTargetFromMission, { groups={[1] = {name=myGroupName} }}, timer.getTime()+ (gTargetDestroyDelay*60) )
		end
		-- THERE ARE INTRADICTION AI REMAINING
		if gIntradiction[myGroupName] ~= nil then
			-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called  From remaining intradiction" , 10 ) end
			myRemainingGroups[#myRemainingGroups+1] = {name=gIntradiction[myGroupName].name}
			gIntradiction[myGroupName] = nil
			myDoRemoveTargets = true
		end
		
		if myDoRemoveTargets == true then
			timer.scheduleFunction(removeTargetFromMission, { groups=myRemainingGroups }, timer.getTime()+ (gTargetDestroyDelay*60) )
		end 
		-- Group.destroy( Group.getByName( gIntradiction[input.group].group) )
		-- gIntradiction[input.group] = nil
	-- end
	
		if gTargetsExpire == false and gTargets[myGroupName] ~= nil then
			--if gTargets[myGroupName].activated == false then 
				-- if Debugging == true then printDebug ("EventHandler" , "Orphaned mission or target" , 10 ) end
				gTargets[myGroupName].orphaned = timer.getTime()
			--end 
		end 
		
	else
		local myTempGroup = {}
		local myCount = 1 
		for team, value in pairs(gPlayerGroups[myGroupName].units) do
			-- if Debugging == true then printDebug ("EventHandler" , "checking if " .. value.name  .. " is still in group"  , 30 ) end 
			if value.name ~= input.unit  then
				-- if Debugging == true then printDebug ("EventHandler" , value.name .. " is still in group"  , 30 ) end 
				myTempGroup[myCount] = value 
				myCount = myCount + 1
			end 
		end
		gPlayerGroups[myGroupName].units = {}
		for i, value in pairs(myTempGroup) do
			gPlayerGroups[myGroupName].units[i] = value
		end	
	end 

	
	--if Debugging == true then printDebug ("EventHandler" , input.unit .. " has left the mission"  , 30 ) end 
end

function doVectors (input)
	local myLanguage = gPlayerGroups[input.group].preferences.language
	if input.setting == gSayThis["English"].menu_vectors_items[1] then
		if gTargets[input.group] ~= nil then 
			doInstructPlayers ( {group=input.group , instruct="all"} )
		else
		
		end 
	end 
	
	if input.setting == gSayThis["English"].menu_vectors_items[2] then
		if gTankers[input.group] ~= nil then
			local myDistance = getDistanceBetweenUnits( input.unit, gTankers[input.group].name )
			local myConvertedDistance = string.format("%.1f" , myDistance/1000) .. " " .. gSayThis[myLanguage].kilometers
			if gPlayerGroups[input.group].preferences.measure == "feet" then myConvertedDistance = string.format("%.1f" , myDistance*MILES) .. " " .. gSayThis[myLanguage].miles end
			local myText = gSayThis[myLanguage].flyheading .. " " .. string.format ("%03d", getBearingToUnit( input.unit, gTankers[input.group].name))  .. " " .. gSayThis[myLanguage].sayfor .." " .. myConvertedDistance .."."
			myText = myText .. " " .. gSayThis[myLanguage].tanker .. " " .. gSayThis[myLanguage].frequency .. " " ..  gTankers[input.group].frequency .. " " .. gSayThis[myLanguage].tacan .. " " .. string.format("%03d" ,gTankers[input.group].tacan.channel) .. gTankers[input.group].tacan.mode
			doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
		else
			doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=gSayThis[myLanguage].notanker })
		end
	end 
	
	if input.setting == gSayThis["English"].menu_vectors_items[3] then
		local myPosition = centerUnitCoordinates ( input.unit )
		local myCoalition =  Unit.getCoalition(Unit.getByName(input.unit))
		local myAirport = findClosestAirbase ({position=myPosition ,coalition=myCoalition })

		local myText = gSayThis[myLanguage].flyheading .. " " .. string.format ("%03d", getBearingTwoPoints(myPosition , myAirport.point))  .. " " .. gSayThis[myLanguage].sayfor
		
		local myConvertedDistance = string.format("%.1f" , myAirport.distance/1000) .. " " .. gSayThis[myLanguage].kilometers
		if gPlayerGroups[input.group].preferences.measure == "feet" then myConvertedDistance = string.format("%.1f" , myAirport.distance*MILES) .. " " .. gSayThis[myLanguage].miles end
		
		myText = myText .." " .. myConvertedDistance  .. " " .. gSayThis[myLanguage].sayfor .. " " .. myAirport.name .. " " .. gSayThis[myLanguage].airfield
		
		
		doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=myText })
	-- if gTargets[group_name]
		
	-- end
	end 
	
	if input.setting == gSayThis["English"].menu_vectors_items[4] then
		local myPosition = centerUnitCoordinates ( input.unit )
		local myAirport = findClosestAirbase ({position=myPosition})
		if myAirport.distance < 20000 then 
			local myLocation = myAirport.point
			local myLocation = getPointOnRadian ( { diameter=1000 , pos=myLocation , angle = myAirport.angle })
			local myLocation = getPointOnRadian ( { diameter=200 , pos=myLocation , angle = myAirport.angle+(math.pi/2) })
			myLocation.y = land.getHeight{x = myLocation.x, y = myLocation.z}
			trigger.action.smoke(myLocation, 2 )
			doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=gSayThis[myLanguage].smokeon .. " " .. myAirport.name })
		else
			doPrintThis ({clearview = gClearView  , group=input.group, duration= 30 , text=gSayThis[myLanguage].notclose  .. " " .. myAirport.name })
		
		end 
	end 
	
end 

function getNewTarget ( input )
	-- local myTargetsAirborne = {[1]= "TF-51D", }
	-- local myTargetsGround = {[1]= "Ural-375 ZU-23", } 
	-- local myTargetsNaval = {[1]= "Dry-cargo ship-1", }
	local myRules = {} -- to hold the rules of engagement id and value
	input.enterservice = gPlayerGroups[input.group].enterservice
	input.retired = gPlayerGroups[input.group].retired
	input.country = gPlayerGroups[input.group].country
	input.accurate = gPlayerGroups[input.group].preferences.historicalaccurate
	
	if gTargets[input.group] ~= nil then
		--if Debugging == true then printDebug ("EventHandler" , "Cleaning up targets for " .. input.group  , 30 ) end 
		-- if Debugging == true then printDebug ("EventHandler" , "Remove targets called  From Get New Target" , 10 ) end
		timer.scheduleFunction(removeTargetFromMission, {groups=gTargets[input.group].groups , friendlygroups=gTargets[input.group].friendlygroups , group=input.group } , timer.getTime()+ (gTargetDestroyDelay*60) )
		gTargets[input.group] = nil
		gHiddenTargets[input.group] = nil
		gLocationTriggers[input.group] = nil
		removeActiveMissions ( {group=input.group , } )		
	end 
		
	local myFriendlyCoa = Group.getCoalition(Group.getByName(input.group))
	local myEnemyCoa = coalition.side.RED
	local myEnemyCountry = gRedCountries[math.random(1,#gRedCountries)]
	if myFriendlyCoa == coalition.side.RED then 
		myEnemyCoa = coalition.side.BLUE
		myEnemyCountry = gBlueCountries[math.random(1,#gBlueCountries)]
	end 
	gTargetsCount = gTargetsCount + 1 
	local myTargetName = "Enemy " ..  gTargetsCount
	local myFirstUnit = Unit.getName(Group.getByName(input.group):getUnit(1))
	local myUnitPostion = centerUnitCoordinates ( myFirstUnit )
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	local myPosition = getPointOnRadian ( { diameter=myRandomDistance , pos=myUnitPostion  , angle=math.random(1,6) } )
	
	
	local myTargetGroups = {}
	myTargetGroups[#myTargetGroups+1] = {name=myTargetName .. "-" .. #myTargetGroups+1 , group=input.group}
	
	local myRememberCategory = input.mission.category
	
	if ( input.mission.category == MissionCombat.ESCORT.category ) then
		input.mission.category = MissionCombat.FIGHTER.category -- SWAP THE SELECTED FIND TO BE A FIGHTER
		local myEscortsTable = checkTargetTables (input) -- LOOK FOR A FIGHTER
		local myEscort = myEscortsTable[math.random( 1, #myEscortsTable )]
		--if Debugging == true then  printDebug ( "EventHandler" , "Escort: " .. TargetHold.escort.type , 10 ) end 
		local myPylons = Targets[string.upper(myEscort.type:gsub('[%p%c%s]', '') )].pylons
		local myPayload = {  ["fuel"] = myEscortsTable.fuel , ["pylons"] = myPylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		input.mission.category = MissionCombat.BOMBER.category -- SWITCH THE FIND NOW TO TYPE OF BOMBER
		myTargetGroups[#myTargetGroups+1] = {name=myTargetName .. " " .. #myTargetGroups+1 , group=input.group , payload=myPayload , type=myEscort.type, escort=true , }

	end
		-- CONVOY WAS SELECTED AS INPUT
	if input.mission.category == MissionCombat.CONVOYARMORED.category or  input.mission.category == MissionCombat.OUTPOST.category  then
		input.mission.category = MissionCombat.ARMORED.category
		myTargetGroups[1].isconvoy = true
	end
	
	
	local myTargetTable = checkTargetTables (input) -- LOOK FOR A TARGET
	local myActiveTarget = myTargetTable[math.random( 1, #myTargetTable )]
	input.mission.category = myRememberCategory

	-- if Debugging == true then printDebug ("EventHandler" , #myActiveTarget , 10 ) end
	
	local myGroupCategory = Group.Category.AIRPLANE
	local myAltModify = 1000 --PLANES GET 1000 FEET PER RANDOM ALT / HELICOPTERS MODIFIED BELOW
	local mySpeed = myActiveTarget.speed
	local myPayload = {  ["fuel"] = myActiveTarget.fuel , ["pylons"] = myActiveTarget.pylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
	if myActiveTarget.enterservice <= 1958 then 
			myPayload.flare = 0 
			myPayload.chaff = 0 
	end 
	local mySurfaceTypes = {[1]="Land" , [2]="Water" } 
	--local myTargetFlightDistance = 50000
	local myTargetFlightDistance = math.random (1,5) * 10000
	local myType = "Turning Point"
	local myAction = "Fly Over Point" 

	
	if myActiveTarget.medium =="Airborne" then
		if myActiveTarget.wing =="rotary" then 
			mySurfaceTypes = {[1]="Land" ,}
			myAltModify = 100 --HELICOPTER GET 100 FEET PER RANDOM ALT
			myGroupCategory = Group.Category.HELICOPTER
			myPayload = {  ["fuel"] = myActiveTarget.fuel , ["pylons"] = myActiveTarget.gpylons , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		end 
		myRules.id = AI.Option.Air.id.ROE  -- AIRCRAFT RULES OF ENGAGEMENT
		if input.menu == gSayThis[gPlayerGroups[input.group].preferences.language].menu_mission[2] then myRules.value = AI.Option.Air.val.ROE.WEAPON_HOLD else myRules.value = AI.Option.Air.val.ROE.OPEN_FIRE end
		--if (input.menu == MissionMenu[1]) then myRules.value = AI.Option.Ground.val.ROE.WEAPON_HOLD else myRules.value = AI.Option.Ground.val.ROE.OPEN_FIRE end
	elseif myActiveTarget.medium =="Water" then
		myGroupCategory = Group.Category.SHIP
		mySurfaceTypes = {[1]="Water" ,} 
		myAltModify = 0 --SHIP GET 0 FEET PER RANDOM ALT
		myRules.id = AI.Option.Naval.id.ROE
		if input.menu == gSayThis[gPlayerGroups[input.group].preferences.language].menu_mission[2] then  myRules.value = AI.Option.Naval.val.ROE.WEAPON_HOLD else myRules.value = AI.Option.Naval.val.ROE.OPEN_FIRE end
	elseif myActiveTarget.medium =="Ground" then
		mySurfaceTypes = {[1]="Land" ,} 
		myGroupCategory = Group.Category.GROUND
		myPayload = nil 
		myTargetFlightDistance = 10000
		myAction = "On Road"
		myAltModify = 0 --SHIP GET 0 FEET PER RANDOM ALT
		myRules.id = AI.Option.Ground.id.ROE -- GROUND RULES OF ENGAGEMENT
		if input.menu == gSayThis[gPlayerGroups[input.group].preferences.language].menu_mission[2] then  myRules.value = AI.Option.Ground.val.ROE.WEAPON_HOLD else myRules.value = AI.Option.Ground.val.ROE.OPEN_FIRE end
	end 
	
		-- FORMATION TYPES
	local myFormation = formation.WWIIBomberOpen
	if ( input.mission.category == MissionCombat.BOMBER.category or input.mission.category == MissionCombat.ESCORT.category)  and myActiveTarget.retired < 1950 then
		myFormation = formation.WWIIBomberTight
	elseif input.mission.category == MissionCombat.FIGHTER.category or input.mission.category == MissionCombat.TRAINER.category then
		myFormation = formation.WWIIFighterTight
	elseif input.mission.category == MissionCombat.ROTARY.category then
		myFormation = formation.RotaryWedge
	elseif input.category == CombatCategory.Shipping then
		
	end
	
	-- FIND THE TARGETS SPAWNING POINT AND ALTITUDE
	local myRandomDistance = gPlayerGroups[input.group].preferences.targetrange + (math.random ( 3 , 10 )*1000)
	local myStartingPosition = findMatchingSurfacePoints ( {unit=Unit.getName(Group.getByName(input.group):getUnit(1)) ,surfacetypes=mySurfaceTypes, distance=myRandomDistance , samples=12, precision=input.mission.diameter } )
	local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceTypes, distance=myTargetFlightDistance , samples=15, precision=input.mission.diameter } )
	local myHeading = getBearingTwoPoints(myStartingPosition.position , myEndingPosition.position) -- HEADING
	local myHighestTerrain = findLowestTerrain ( {point=myStartingPosition.position, samples=8, distance=5000 , } ) 
	local mySpawnAlt = math.floor(((math.random(gAirborneTargetAlt.min,gAirborneTargetAlt.max) * myAltModify ) + (myHighestTerrain.highest_elevation*FEET))/1000 + 1 * 0.5) * 1000 -- ROUND TO NEAREST THOUSAND
	-- CREATE TARGETS WAYPOINT 
	if myGroupCategory == Group.Category.GROUND then
		myStartingPosition.position.x, myStartingPosition.position.z = land.getClosestPointOnRoads('roads' , myStartingPosition.position.x, myStartingPosition.position.z ) -- FIND A CLOSE ROAD TO ENDPOINT
		myEndingPosition.position.x, myEndingPosition.position.z = land.getClosestPointOnRoads('roads' , myEndingPosition.position.x, myEndingPosition.position.z ) -- FIND A CLOSE ROAD TO ENDPOINT
	end
	if myActiveTarget.radar ~= nil or myActiveTarget.speed == 0 or input.mission.category == MissionCombat.OUTPOST.category then
		myEndingPosition.position = myUnitPostion
		myHeading = getBearingTwoPoints(myStartingPosition.position , myUnitPostion) 
		myStartingPosition.position = getPointOnRadian ( { diameter=math.random(6,10) , pos=myStartingPosition.position  , angle=math.random(1,3)*(math.pi*2/3) } )
		mySpeed = 0 -- none of these types should move
	end	
	
	--if Debugging == true then printDebug ("EventHandler" , "Heading " .. myHeading , 10 ) end
	local myWaypoints = {}
	myWaypoints[#myWaypoints+1] = { action = myAction, pos=myEndingPosition.position , alt = mySpawnAlt  , altType="RADIO" , speed =mySpeed }

	-- primary or lead target
	myTargetGroups[1].type = myActiveTarget.type
	myTargetGroups[1].payload = myPayload
	myTargetGroups[1].radar = myActiveTarget.radar
	myTargetGroups[1].convoy = myActiveTarget.convoy
	
	local function ROEforSpawn (input)
				SendOptionToGroup (  input.name , input.id, input.value )
	end
	
	for tg_key,tg_value in pairs( myTargetGroups ) do 
		-- CREATE THE UNITS ---
		local myUnits = {}
		local myUnitsForGroup = {}
		for i=1 , gPlayerGroups[input.group].preferences.difficulty  do
			myUnits[#myUnits+1] = { name = tg_value.name .. #myUnits+1 , heading = myHeading , skill=gEnemySkillLevel , type=tg_value.type , offset = {x=1000,z=1000}, payload=tg_value.payload  }
			myUnitsForGroup[#myUnitsForGroup+1]= { name=myUnits[#myUnits].name , }
					--- BUILDING ANY RADAR UNITS
			-- if tg_value.radar ~= nil or tg_value.convoy ~= nil  then
			if tg_value.radar ~= nil or tg_value.isconvoy ~= nil  then
			
				local myNumberUnits = 1 
				local myTable = myActiveTarget.radar
				if tg_value.convoy ~= nil then myTable = tg_value.convoy end 
				for radarKey,radarValue in pairs( myTable ) do
					local myOffset = {}
					myOffset.x = math.random( -50 , 50 ) * myNumberUnits
					myOffset.z = math.random( -50 , 50 ) * myNumberUnits
					myUnits[#myUnits+1] = { name = tg_value.name .."U".. #myUnits+1 , heading = myHeading , skill = gEnemySkillLevel , type=radarValue, offset = myOffset }
					myNumberUnits  =  myNumberUnits  + 1
				end
				if input.mission.category == MissionCombat.OUTPOST.category then myWaypoints = {} end
			end 	
		end 
		
		if tg_value.escort ~= nil then
			local myAltDifference = 1000
			mySpawnAlt = mySpawnAlt + myAltDifference
			myStartingPosition.position = getPointOnRadian ( { diameter=2000 , pos=myStartingPosition.position , angle = (myHeading*math.pi/180)-math.pi })
			for key,value in pairs( myWaypoints ) do
				myWaypoints[key].alt = mySpawnAlt
			end 
			local myInput = { lead=myTargetGroups[1].name , trail = tg_value.name , center=-500 , above=myAltDifference*FEET_TO_METERS , behind=-300 ,}
			timer.scheduleFunction(doFollowFormation, myInput, timer.getTime() + 4  )
			myFormation = formation.WWIIFighterTight
		end 
		
		gCurrentGroupID = gCurrentGroupID + 1 
		local myPosition = getPointOnRadian ( { diameter=(tg_key-1)*50 , pos=myStartingPosition.position , angle = myStartingPosition.angle+(math.pi/2) })
		local mySpawn = { name=tg_value.name, groupId=gCurrentGroupID , tasks = myFormation, waypoints=myWaypoints , lateActivation=true,  units=myUnits, skill=gEnemySkillLevel , action=myAction , spawn_type=myGroupCategory , type=tg_value.type , position=myPosition , heading=myHeading , country=myEnemyCountry , speed=mySpeed , alt=mySpawnAlt , altType="RADIO", }
		local myBuiltSpawn = doBuildSpawn (mySpawn)
		--deReference ( myBuiltSpawn ) 
		coalition.addGroup(country.id[myEnemyCountry], myGroupCategory, myBuiltSpawn ) -- SPAWN THE Group
		 
		timer.scheduleFunction( ROEforSpawn, {name=tg_value.name,id=myRules.id, value=myRules.value} , timer.getTime()+ 5 )
				
	end
	
	-- CREATE THE TARGET TABLE
	local myTargetKey = string.upper(myActiveTarget.type:gsub('[%p%c%s]', '') )
	local myTypeName = myActiveTarget.type 
	if Targets[myTargetKey].typename ~= nil then myTypeName = myActiveTarget.typename end
	
	local myPlayerGroups = {[1]={name=input.group,type=gPlayerGroups[input.group].type}}
	local myMessages =	{[1]="flyheading" , [2]="clearedtofire",}
	local myTriggers = {[1]={groups=myPlayerGroups, atgroup=myTargetGroups[1].name} , -- group near atgroup or atpoint
						[2]={groups=myPlayerGroups, atgroup=myTargetGroups[1].name},
						}
	local myHiddenTargets = {[1]=myTargetGroups ,}


	gTargets[input.group] = { name=input.group, target=myTargetName , groups=myTargetGroups , type=myActiveTarget.type , 
	typename=myTypeName, alt=mySpawnAlt, startpoint=myStartingPosition.position, activated=false , key=myTargetKey , roe=myRules ,  
	triggers=myTriggers, messages=myMessages , phrasecount=1}
	
	gHiddenTargets[input.group] = { name=input.group,  groups=myHiddenTargets , triggers=myTriggers , menu=input.menu }
		
	--gHiddenTargets[input.group] = { name=input.group, target=myTargetName , groups=myTargetGroups }

	doInstructPlayers ( {group=input.group} )
	
	doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})
end 

-- LOOK FOR MATCHING TARGETS
function checkTargetTables (input)
	
		local myTargets = { } -- HOLD ALL THE TARGETS THAT MATCH SELECTED CATEGORY, YEARS, AND AIRCRAFT
		for targetKey,targetValue in pairs(Targets) do -- ITERATE THROUGH THE TARGEST TABLLE 
		-- ITERATE THROUGH LOOKING FOR MATCHING TARGETS CATEGORIES
		-- if Debugging == true then  printDebug ( "EventHandler" , "Available targets: " ..  Targets[targetKey].category .. " " .. input.mission.category , 10 ) end
		if ( string.upper(Targets[targetKey].category) == string.upper(input.mission.category) ) or (input.category == CombatCategory.ZRandom) then -- DOES THE TARGET CATEGORY MATCH THE menu SELECTION or random
		
			local doSpawn = {year=false , historical=true , wwii=true}
	
			if ( input.enterservice >= Targets[targetKey].enterservice and input.enterservice <= Targets[targetKey].retired ) or ( Targets[targetKey].enterservice >= input.enterservice and Targets[targetKey].enterservice <= input.retired ) then
				doSpawn.year = true
				-- if Debugging == true then  printDebug ( "EventHandler" , Targets[targetKey].type , 10 ) end
			end
			
			-- CHECK FOR A HISTORICALLY ACCURATE FOE
			-- if ( gHistoricalFoes == 1 ) and (input.country == Targets[targetKey].country) then -- the player and target match countries
			if ( input.accurate == "Accurate" ) and (input.country == Targets[targetKey].country) then -- the player and target match countries
				doSpawn.historical = false 
			end
			
			-- CHECK FOR WWII ASSET PACK
			if ( gWWIIAssets == false and Targets[targetKey].asset == "WWII" ) then 
				doSpawn.wwii = false
			end 
			
			-- check the flag for year and historical and wwii asset pack
			--if (doSpawn.year == true and doSpawn.historical == true and doSpawn.wwii == true  ) then
			if (doSpawn.year == true and doSpawn.historical == true and doSpawn.wwii == true ) then
				myTargets[#myTargets+1] =  Targets[targetKey]
				-- if Debugging == true then  printDebug ( "EventHandler" , "Match: " .. Targets[targetKey].type  .. " " .. Targets[targetKey].enterservice .. " - " ..  Targets[targetKey].retired .. " Player: " .. PlayerAircraft.enterservice .. " - " .. PlayerAircraft.retired  , 10 ) end
			
			end
		end 
	end

	-- local myActiveTarget = myTargets[math.random( 1, #myTargets )]
	-- --if Debugging == true then  printDebug ( "EventHandler" , "Random Pick: " .. myActiveTarget.type  .. " " .. myActiveTarget.enterservice .. " - " ..  myActiveTarget.retired .. " Player: " .. PlayerAircraft.enterservice .. " - " .. PlayerAircraft.retired  , 10 ) end
	-- return myActiveTarget
	return myTargets
	
end

function findMatchingSurfacePoints ( input )
	-- FIND ALL THE POINTS IN A CIRCLE THAT MATCH 
	local myMatchingTrue = false
	local mySurfaceMatching = {surface=input.surfacetypes, unit=input.unit , position=input.position , distance=input.distance , samples=input.samples , precision=input.precision }
	local mySpeedBrake = 1
	local myTargetPos = {}
	local myEntireSet = {}
	local myReturn = {}
	
	while myMatchingTrue == false do
		--if Debugging == true then  printDebug ( "EventHandler" , "Making a loop through terrain finding engine " .. mySpeedBrake  , 10 ) end
		local myMatchingSurfaces = findMatchingSurfaceTypeCircle ( mySurfaceMatching )
		if #myMatchingSurfaces >= 1 or mySpeedBrake > 50 then 
			myMatchingTrue = true
			if #myMatchingSurfaces >= 1 then 
				myTargetPos = myMatchingSurfaces[math.random(1,#myMatchingSurfaces)] 
				myEntireSet = myMatchingSurfaces
			end 
		end 
		mySurfaceMatching.distance=mySurfaceMatching.distance + ( 5000 * (mySpeedBrake/2)) 
		mySpeedBrake = mySpeedBrake + 1  
	end
	
	if input.allpoints ~= nil then 
		myReturn = myEntireSet
	else
		myReturn = myTargetPos
	end	
	
	return myReturn
end

function returnAllUnitsOfGroup ( input )

	local myCoalition =  Group.getCoalition(Group.getByName(input.group))
	local myPlayers = coalition.getPlayers(myCoalition)
	local myGroupUnits = (Group.getByName(input.group):getUnits())
	local myAIinGroup = {}
	local myPlayersInGroup = {}
	local playersInGroup = false
	local AIinGroup = false 
	local myPlayersTable = {}
	for unit_name ,unit_value in pairs(myPlayers) do
		myPlayersTable[Unit.getPlayerName(unit_value )] = unit_value
	end 

	for unit_name ,unit_value in pairs(myGroupUnits) do
		if myPlayersTable[Unit.getPlayerName(unit_value )] ~= nil then
			myPlayersInGroup[Unit.getPlayerName(unit_value )] = unit_value
			playersInGroup = true
		else
			myAIinGroup[Unit.getName(unit_value)] = unit_value
			AIinGroup = true 
		end
	end
	
	local myReturn = {}
	if AIinGroup == true then
		myReturn.ai = myAIinGroup
		-- if Debugging == true then printDebug ("EventHandler" , "AI in group " .. input.group   , 5 ) end
	end 
	
	if playersInGroup == true then
		myReturn.players = myPlayersInGroup
	--	if Debugging == true then printDebug ("EventHandler" , "Players in group "  .. input.group   , 5 ) end
	end 
	return myReturn
end

function destroyUnitOne ( input )
		-- if Debugging == true then printDebug ("EventHandler" , "Starting to destroy group " .. input.group  , 10 ) end 
	-- myUnits = Group.getUnits(Group.getByName(gTargets[input.group].groups[1].name))
	-- for tg_key,tg_value in pairs( myUnits ) do
		-- if Debugging == true then printDebug ("EventHandler" , "Units remaining " .. Unit.getName(tg_value), 10 ) end 
	-- end 
	local myTargetUnitName = ""
	local myUnit = 1
	if input.friendly ~= nil then
		-- for index, data in pairs(Group.getByName(input.group):getUnits()) do
			-- local myUnitName = Unit.getName ( data )
			-- if gPlayers[myUnitName] == nil then
				-- myTargetUnitName = myUnitName
			-- end 
		-- end 
	  myTargetUnitName = Unit.getName ( Group.getByName(gTargets[input.group].groups[2].name):getUnit(1) )
	else  
		
		myTargetUnitName = Unit.getName ( Group.getByName(gTargets[input.group].groups[1].name):getUnit(1) )
	end
	
	destroyUnit ( {unit=myTargetUnitName , power=500} )
	
	--doUnitLandClosestAirfield ( {unit=myTargetUnitName , notcoalition=Unit.getCoalition(Unit.getByName(myTargetUnitName ))} )
	
end

function activateTanker ( input ) 

	-- late activate spawn the tanker
	--
	--gTankers
	if  gTankers[input.group] == nil  then -- is the tanker already been spawned?
		if gTankerFreqeuncy > 135 then gTankerFreqeuncy = 129.5 else gTankerFreqeuncy = gTankerFreqeuncy + 1  end 
		local myRandomTACAN = doRandomTACAN ({mode="X",}) 
		gTargetsCount = gTargetsCount + 1 
		gTankers[input.group] = {name="Tanker " .. gTargetsCount , frequency=gTankerFreqeuncy , tacan=myRandomTACAN}
	end
	
	local myTankerLocation = centerUnitCoordinates ( input.unit )
	local myHeading = doGetUnitHeading ( {callsign=input.unit} )
	
	
	-- myTankerLocation = getPointOnRadian ( { diameter=math.random(10,15)*1000 , pos=myTankerLocation , angle = math.random(1,6) })
	local myDiameter = 30000
	local myHeadingAngle = myHeading.angle+(math.random(-1,1))
	myTankerLocation = getPointOnRadian ( { diameter=math.random(5,10)*1000 , pos=myTankerLocation , angle=myHeadingAngle  })
	local myStartingLocation = myTankerLocation
	local myRaceTrackLocation = getPointOnRadian ( { diameter=myDiameter , pos=myTankerLocation , angle=myHeadingAngle })

	
	local myTankerHeading = myHeading.bearing
	local myTankerKey = string.upper(AircraftType[gPlayerGroups[input.group].key].tanker:gsub('[%p%c%s]', '') )

	local myRefuelSpeed = Targets[myTankerKey].speed*.55
	local myWaypoints = {}

	local myAngle = myHeading.angle
	local myTankerAlt = math.random (13,17)*1000
	
	for times=1,4 do -- how many laps
		local myTankerStartLocation = myTankerLocation
		for i=1,8 do -- the turns inside the loops
			local myLocalDiameter = myDiameter		
			if i==1 or math.floor (math.fmod(i, 5)) == 0 then 
				myLocalDiameter = myDiameter*2 
			end 
			myTankerStartLocation = getPointOnRadian ( { diameter=myLocalDiameter , pos=myTankerStartLocation , angle = myAngle })
			myAngle = myAngle - (math.pi/4)
			myWaypoints[#myWaypoints+1] = { action = "Fly Over Point" , pos=myTankerStartLocation , alt = myTankerAlt  , altType="BARO" , speed =myRefuelSpeed }
		end 
	end 
		
	local myTasks = { 
			[1] =  { ["enabled"] = true, ["auto"] = true, ["id"] = "Tanker", ["number"] = 1, ["params"] =  { }, } ,
	}

	local myCountry = country.name[Unit.getByName(input.unit):getCountry()]
 

	
	--myPayload = {  ["fuel"] = Targets[myTankerKey].fuel , ["pylons"] =  {} , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 ,}
	
	local myTankerSpawn = {
						name=gTankers[input.group].name ,
						type=Targets[myTankerKey].type ,
						speed=myRefuelSpeed , -- start out slower than normal 
						alt = myTankerAlt ,
						altType="BARO" ,
						country=myCountry ,
						spawnfrom = "Airborne",
						action ="Fly Over Point" ,
						position=myStartingLocation,
						skill= gFriendlySkillLevel,
						parking=1,
						livery_id=Targets[myTankerKey].blivery ,
						lateActivation = true ,
						heading = myTankerHeading ,
						task = "Refueling" ,
						tasks = myTasks ,
						waypoints = myWaypoints,
						fuel = Targets[myTankerKey].fuel ,
						}

		
		-- mySpawnAirplane (myTankerSpawn)
		local myBuiltSpawn = doBuildSpawn (myTankerSpawn)
		--deReference ( myBuiltSpawn)
		coalition.addGroup(country.id[myCountry], Group.Category.AIRPLANE, myBuiltSpawn ) -- SPAWN THE Group
		
	local function myActivate  ( input )
		trigger.action.activateGroup(Group.getByName(input.name))
	end 
	
	local function myRefuel ( input )
		-- if Debugging == true then printDebug ("EventHandler" , "Sending Refuel " .. input.name, 10 ) end
		local Tanker = {  id = 'Tanker', params = { } }
		SendControlToUnit ( input.name , Tanker , true )
		-- if Debugging == true then printDebug ("EventHandler" , "Sent Refuel" , 10 ) end

	end 
	timer.scheduleFunction(myActivate, {name=gTankers[input.group].name} , timer.getTime()+ 3 )
	
	timer.scheduleFunction( ActivateTacan, {group=gTankers[input.group].name,channel=gTankers[input.group].tacan.channel, mode=gTankers[input.group].tacan.mode, callsign=gTankers[input.group].tacan.callsign, AA=true , system=4 } , timer.getTime()+ 4 )
	local mySetFrequency = { id = 'SetFrequency', params = { frequency = gTankers[input.group].frequency*1000000 , modulation = 0 , } }
	

	SendCommandToGroup ( gTankers[input.group].name , mySetFrequency  )	
	-- local myLocation = { callsign = gTankers[input.group].name, point=myTankerLocation   , type = "Race-Track" , alt=myTankerAlt , speed=myRefuelSpeed , racetrack_point= myTankerWaypoint }  -- "Race-Track" or "Circle" -- zone = "TaskGroupSpawnZone"
	-- timer.scheduleFunction(doHoldPattern, myLocation, timer.getTime()+ 5 )

	--timer.scheduleFunction(myRefuel, {name=gTankers[input.group].name} , timer.getTime()+ 6 )

	doVectors ({group=input.group, unit=input.unit,setting=gSayThis["English"].menu_vectors_items[2]})

	-- end 
end

function shutdownEvent ( input )
	local myCoalition =  Unit.getCoalition(Unit.getByName(input.unit))
	local myPlayers = coalition.getPlayers(myCoalition)
	local myAIShutdown = true 
	
	for i = 1, #myPlayers do
		if Unit.getName(myPlayers[i]) == input.unit then 
			myAIShutdown = false
			-- if Debugging == true then printDebug ("EventHandler" , "Player Shutdown" , 10 ) end
		end 
	end
	
	if myAIShutdown == true then
		local myUnit = Unit.getByName(input.unit)
		removeTarget ( { unit=input.unit , group=input.group } )
		Unit.destroy (myUnit )
	end 

end

function removeTarget ( input )
	
	local myUnits = Group.getUnits(Group.getByName(input.group))
	
		if gVisibleTargets[input.group] ~= nil then -- THIS TARGET BELONGS TO AN ACTIVE MISSION OR TARGET
			local myGroupBelong = gVisibleTargets[input.group].name
			
			local myRequired = false

			if gTargets[myGroupBelong] ~= nil then 
				if gTargets[myGroupBelong].groups ~= nil then 
					if gTargets[myGroupBelong].required ~= nil then
						
						for tg_key,tg_value in pairs( gTargets[myGroupBelong].groups ) do
						--  if Debugging == true then printDebug ("EventHandler" , "This group has a required Target " .. tg_value.name, 10 ) end
						  if gTargets[myGroupBelong].required[tg_value.name] ~= nil then
							myRequired = true 
							--if Debugging == true then printDebug ("EventHandler" , "a Required Target ", 10 ) end
						  end 
						end
					end 
						
					for tg_key,tg_value in pairs( gTargets[myGroupBelong].groups ) do
						if tg_value.respawn ~= nil and tg_value.name == input.group and myRequired == true then
							tg_value.countryid = Unit.getCountry(Group.getByName(input.group):getUnit(1))
							tg_value.group = myGroupBelong
							tg_value.target_key = tg_key
							timer.scheduleFunction(doRespawn, tg_value , timer.getTime()+ 5 )
							-- if Debugging == true then printDebug ("EventHandler" , "a respawning target was destroyed ", 10 ) end
						
						elseif tg_value.name == input.group and #myUnits <= 1 then
							-- if Debugging == true then printDebug ("EventHandler" , "Remove target for " .. tg_value.name, 10 ) end

							table.remove (gTargets[myGroupBelong].groups, tg_key)
							gVisibleTargets[input.group] = nil 
						end 
					end
				end 

				-- ARE THERE NO MORE TARGETS AVAILABLE
				if #gTargets[myGroupBelong].groups < 1  then 
					-- if Debugging == true then printDebug ("EventHandler" , "No Groups Remain for " ..myGroupBelong  , 10 ) end
					local myNoReturn = gTargets[myGroupBelong].noreturn
					gTargets[myGroupBelong] = nil
					if myNoReturn == nil then 
						returnToBaseDirections ( {group=myGroupBelong} )
					end
		
					
				end 
				--if Debugging == true then printDebug ("EventHandler" , "Units remaining " .. #myUnits , 10 ) end
		
		end
	end 
	
end

function landingEvent ( input )
	--if Debugging == true then printDebug ("EventHandler" , "Landing Event For : " .. input.unit .. " " .. input.group  , 30 ) end 
	
	local myCoalition =  Unit.getCoalition(Unit.getByName(input.unit))
	local myCountry = Unit.getCountry(Unit.getByName(input.unit))
	
	local myPlayers = coalition.getPlayers(myCoalition)
	local myAILanded = true 
	
	for i = 1, #myPlayers do
		if Unit.getName(myPlayers[i]) == input.unit then 
			myAILanded = false
		end 
	end
	
	if myAILanded == true then
		local myGroupName = Group.getName(Unit.getGroup(Unit.getByName(input.unit)))
		local myRequired = false -- START OUT WITH NO GROUPS HAVING A RESPAWN REQUIRED
		for group_name ,group_value in pairs(gTargets) do -- IN THE GROUPS
			if group_value.required ~= nil then -- DOES THIS TARGET REQUIRE A RESPAWN
				for tg_key,tg_value in pairs( group_value.groups ) do --LOOK THROUGH THE GROUPS WHICH ARE ALIVE
					if group_value.required[tg_value.name] ~= nil then -- DOES IT MATCH A REQUIRED GROUPS
						myRequired = true 
					end 
				end         
				for tg_key,tg_value in pairs( group_value.groups ) do -- THROUGH THE GROUPS AGAIN LOOKING FOR MATCH
					if tg_value.respawn ~= nil and myGroupName == tg_value.name and myRequired == true then
						tg_value.countryid = Unit.getCountry(Unit.getByName(input.unit))
						tg_value.group = group_name
						tg_value.target_key = tg_key
						tg_value.landingevent = input.unit 
						timer.scheduleFunction(doRespawn, tg_value , timer.getTime()+ 5 )
					end
					
				end
			end 
			
			local unit_airborne = false
			local myUnits = Group.getUnits(Group.getByName(gTargets[group_name].groups[1].name))
			for unit_id , unit_array in pairs(myUnits) do
				if Unit.inAir(unit_array) == true then unit_airborne = true end 
			end 	
			if unit_airborne == true or myRequired == true then
				
			elseif gMissionsRunning[group_name] == nil then
				gTargets[group_name] = nil 
			end
		end
		--if Debugging == true then printDebug ("EventHandler" , "Landed Unit " ..  myLandedUnit , 10 ) end
	
	else
		--if Debugging == true then printDebug ("EventHandler" , "Player landed : " .. input.unit .. " " .. input.group  , 30 ) end
		
	end 
 
 
end 

function doRespawn ( input )

		if input.nextspawn ~= nil then 
			
			local myRemove = false 
			if input.landingevent ~= nil then
				local myUnits = Group.getUnits(Group.getByName(input.name))
				if #myUnits == 1 then 
					Unit.destroy (Unit.getByName(input.landingevent) )
					myRemove = true
					-- if Debugging == true then printDebug ("EventHandler" , "Unit landed and destroyed from group " .. input.target_key , 10 ) end
				end 
				-- if Unit.inAir(unit_array) == true and #myUnits > 1 then myRemove = true end 
				 
			end
			
			if Group.getByName(input.name) == nil or myRemove == true then 	
				trigger.action.activateGroup(Group.getByName(input.nextspawn ))
				gVisibleTargets[input.nextspawn] = gTargets[input.group]
				table.remove (gTargets[input.group].groups, input.target_key )
				gVisibleTargets[input.name] = nil 
				-- if Debugging == true then printDebug ("EventHandler" , "Respawn No unit still active for " .. input.name , 10 ) end
			else
				-- if Debugging == true then printDebug ("EventHandler" , "Units still active " .. input.name , 10 ) end
			end 
		elseif killregenerates == nil then 
			input.respawn.lateActivation = true			
			local myBuiltSpawn = doBuildSpawn (input.respawn)
			coalition.addGroup(input.countryid, input.respawn.spawn_type, myBuiltSpawn )
			timer.scheduleFunction(Group.activate, Group.getByName( myBuiltSpawn.name), timer.getTime()+ 3 )
		end


	--if Debugging == true then printDebug ("EventHandler" , "This unit gets respawned " ..  input.name .. " country " .. country.name[input.countryid], 10 ) end  
end

function spawnInterdiction ( input )
	local myTargetRange = math.random(10,20) * 1000
	local function myDelaySpawn ( group )
		trigger.action.activateGroup(Group.getByName(group))
	end
			
	local group_name = input.group
	local myTargetType = {}
	myTargetType.country = Targets[gPlayerGroups[group_name].key].country
	myTargetType.enterservice = gPlayerGroups[group_name].enterservice
	myTargetType.retired = gPlayerGroups[group_name].retired
	myTargetType.country = gPlayerGroups[group_name].historicalcountry
	myTargetType.accurate = gPlayerGroups[group_name].preferences.historicalaccurate 
	myTargetType.mission = MissionCombat.FIGHTER
	local myPossibleTargets = checkTargetTables (myTargetType) -- LOOK FOR A TARGET 
	local myEnemyTargets=myPossibleTargets[math.random( 1, #myPossibleTargets )] 
	gIntradiction[group_name] = { group=group_name , type=myPossibleTargets.type }
	
	local myPlayerAlt = getMSLmeters(Unit.getName(Group.getByName(group_name):getUnit(1))) + 1000
	local myPlayerPosition = (Group.getByName(group_name):getUnit(1)):getPoint()
	-- local myTargetRange = gPlayerGroups[group_name].preferences.targetdetect*2
	local myJumpedPostion = getPointOnRadian ( { diameter=myTargetRange , pos=myPlayerPosition , angle=math.random(1,6) })

	local myHeadingEnemy = getBearingTwoPoints(myJumpedPostion , myPlayerPosition )
	
	--if Debugging == true then printDebug ("EventHandler" , group_name  .. " needs to be jumped by " .. myEnemyTargets.type , 10 ) end
	gTargetsCount = gTargetsCount + 1
	local myOppositeSide = getOppositeSide ( {group=group_name} )
	
	-- GET A PAYLOAD
	myEnemyTargets.key = string.upper(myEnemyTargets.type:gsub('[%p%c%s]', '') )
	local myPylons = {[1] = myEnemyTargets.pylons , [2]=myEnemyTargets.gpylons}
	if myEnemyTargets.gpylons == nil then myPylonsChoice = myPylons[1] else myPylonsChoice = myPylons[math.random(1,2)] end -- SOME TARGETS ONLY HAVE ONE PYLON TYPE
	local myPayload  = {  ["fuel"] = myEnemyTargets.fuel , ["pylons"] = myPylonsChoice , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
	if myEnemyTargets.enterservice <= 1958 then 
		myPayload.flare = 0 
		myPayload.chaff = 0 
	end 

	-- GET A TASK
	local myEnemyTask = formation.WWIIFighterOpen -- formation always comes first in task list or will crash game
	myEnemyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }

	-- CREATE THE WAYPOINT
	local myWaypoints = { [1] = { action = "Fly Over Point", pos=myPlayerPosition , alt = myPlayerAlt  , altType="BARO" , speed = myEnemyTargets.speed , }}
	
	-- CREAT THE UNITS
	local myUnits = {}
	for i=1,gPlayerGroups[group_name].preferences.difficulty do
		myUnits[#myUnits+1] = { name = group_name .. " J" .. gTargetsCount .. "U" .. i , heading=myHeadingEnemy,  spawn_type=Group.Category.AIRPLANE , 
		skill = gEnemySkillLevel  , type=myEnemyTargets.type, position=myJumpedPostion  , livery=myEnemyTargets.rlivery, payload=myPayload, alt=myPlayerAlt , speed=myEnemyTargets.speed, altType="BARO", }
	end

	gCurrentGroupID = gCurrentGroupID + 1
	local mySpawn = { name=group_name .. "J" .. gTargetsCount ,groupID=gCurrentGroupID, units=myUnits, skill=gEnemySkillLevel , 
	action= "Fly Over Point" , waypoints=myWaypoints, lateActivation=true , spawn_type=Group.Category.AIRPLANE , type=myEnemyTargets.type, 
	position=myJumpedPostion , heading=myHeadingEnemy , country=myOppositeSide.enemycountry , 
	speed=myEnemyTargets.speed , alt=myPlayerAlt , altType="BARO", tasks=myEnemyTask,}
	local myBuiltSpawn = doBuildSpawn (mySpawn)
	gIntradiction[group_name] = { name=mySpawn.name , type=myPossibleTargets.type }
	coalition.addGroup(myOppositeSide.enemycountryid, Group.Category.AIRPLANE, myBuiltSpawn ) 
	
	timer.scheduleFunction(myDelaySpawn, mySpawn.name , timer.getTime()+ 5 )

end 

function doCalculateJumpPercent ( input )	
	-- if Debugging == true then printDebug ("EventHandler" ,  "Calculate Jump percent" , 10 ) end 
	if gPlayerGroups ~= nil then 
		for group_name , group_value in pairs(gPlayerGroups) do
			if group_value.preferences.jumpedpercent > 0 and gPlayerGroups[group_name].jumped == nil then 

				gPlayerGroups[group_name].interdiction.count = gPlayerGroups[group_name].interdiction.count + 1
				if gPlayerGroups[group_name].interdiction.count > gPlayerGroups[group_name].interdiction.probability then
					gPlayerGroups[group_name].interdiction.percent = gPlayerGroups[group_name].interdiction.percent + gPlayerGroups[group_name].interdiction.rate
					if gPlayerGroups[group_name].interdiction.percent > 90 then 
						gPlayerGroups[group_name].interdiction.percent = 0 
					end
					local myProbabilityRandom = math.random (1,100)
					--if Debugging == true then printDebug ("EventHandler" ,  "Guessed " .. myProbabilityRandom .. " for " .. gPlayerGroups[group_name].interdiction.percent , 10 ) end 
					if gPlayerGroups[group_name].interdiction.percent >  myProbabilityRandom then
						if ((group_value.preferences.jumpedpercent) >= myProbabilityRandom ) and gPlayerGroups[group_name].jumped == nil then
							spawnInterdiction ({group=group_name , })
							gPlayerGroups[group_name].jumped = true
						end
					end 
				end
			end
		end
	end
		
end

function getOppositeSide ( input )
	input.friendlycoa = Group.getCoalition(Group.getByName(input.group))
	input.friendlycountryid =  Unit.getCountry(Group.getByName(input.group):getUnit(1))
	input.friendlycountry = country.name[input.friendlycountryid]
	
	input.enemycoa = coalition.side.RED
	input.enemycountry = gRedCountries[math.random(1,#gRedCountries)]
	input.enemycountryid = country.id[input.enemycountry] 
	
	if input.friendlycoa == coalition.side.RED then 
		input.enemycoa = coalition.side.BLUE
		input.enemycountry = gBlueCountries[math.random(1,#gBlueCountries)]
		input.enemycountryid = country.id[input.enemycountry] 
	end
	return input
end 

function returnToBaseDirections ( input )

	if Group.getByName( input.group ) ~= nil then  
		local myLanguage = gPlayerGroups[input.group].preferences.language
		local myUnitName = Unit.getName ( Group.getByName(input.group):getUnit(1) )
		local myPosition = centerUnitCoordinates ( myUnitName )
		local myCoalition =  Unit.getCoalition(Unit.getByName(myUnitName))
		local myAirport = findClosestAirbase ({position=myPosition ,coalition=myCoalition })
		local myText = gSayThis[myLanguage].targetsdestroyed .. " " .. gSayThis[myLanguage].flyheading .. " " .. string.format ("%03d", getBearingTwoPoints(myPosition , myAirport.point))  .. " " .. gSayThis[myLanguage].sayfor
		local myConvertedDistance = string.format("%.1f" , myAirport.distance/1000) .. " " .. gSayThis[myLanguage].kilometers
		if gPlayerGroups[input.group].preferences.measure == "feet" then myConvertedDistance = string.format("%.1f" , myAirport.distance*MILES) .. " " .. gSayThis[myLanguage].miles end
		myText = myText .." " .. myConvertedDistance  .. " " .. gSayThis[myLanguage].sayfor .. " " .. myAirport.name .. " " .. gSayThis[myLanguage].airfield
		timer.scheduleFunction(doPrintThis, {clearview = gClearView  , group=input.group, duration= 30 , text=myText }, timer.getTime()+ math.random(10,20) )
		doRadioCommand ({unit=Unit.getName ( Group.getByName(input.group):getUnit(1) )})	
	end 
end

function GetAltitudeRangesGroup ( input ) -- toolbox function

	local myLowestAGL = 0
	local myHighestAGL = 0
	local myLowestMSL = 0 
	local myHighestMSL = 0

	for unit_key, unit_value in pairs(Group.getByName(input.group ):getUnits()) do
			local myUnitPoint = unit_value:getPoint()
			if myUnitPoint.y > myHighestMSL then
				myHighestMSL = myUnitPoint.y
			end
			if myUnitPoint.y < myHighestMSL then
				myLowestMSL = myUnitPoint.y
			end
	end
	
	local myAverageMSL = (myHighestMSL-myLowestMSL)/2 + (myLowestMSL)
	
	return ({lowest_msl=myLowestMSL, higest_msl=myHighestMSL, average_msl=myAverageMSL })
end

function fullUpParking ( input ) 
	for key , value in pairs(gPlayerGroups) do
		local myUnitName = Unit.getName ( Group.getByName(key):getUnit(1))
		local myUnit = Unit.getByName(myUnitName)
		local myPosition = Unit.getPoint(myUnit)
		local myCoalition = Unit.getCoalition(myUnit)
		local myCountryID = Unit.getCountry(myUnit)
		local myCountryName = country.name[myCountryID]
		local myAirfield = findClosestAirbase ({position=myPosition ,coalition=myCoalition })
		-- if Debugging == true then printDebug ("EventHandler" ,  myAirfield.id , 2 ) end 
		local myParkingMap = getParkingClosestToActive ({ type=104 , airfield=myAirfield.id  })
		--local myParkingMap = Airbase.getParking(myAirfield.airport , true)
		local myTimes = 5
		for key , value in pairs(myParkingMap) do
			-- if Debugging == true then printDebug ("EventHandler" ,  key .. " " .. value , 2 ) end 
		end 
		for i=1,myTimes do 
			-- if Debugging == true then printDebug ("EventHandler" , "Space " .. myParkingMap[i], 2 ) end 
			local mySpawn = { name="Parking " .. myParkingMap[i] , skill=gFriendlySkillLevel , parking=myParkingMap[i],  spawnFrom= "TakeOffParking" , spawn_type=Group.Category.AIRPLANE, type=value.type, airfield=myAirfield.id , heading=math.pi , country=myCountryName , speed=0 , alt=0 , altType="RADIO",}
			local myBuiltSpawn = doBuildSpawn (mySpawn)
			coalition.addGroup(myCountryID, Group.Category.AIRPLANE , myBuiltSpawn )
			-- if Debugging == true then printDebug ("EventHandler" , "Airfield " .. myPostion.x  , 2 ) end 
		end 
	end 
end 


